@if (componentData) {
  @if (componentData.projectData.allowAutomationWorkflow) {
    @switch (componentData.projectData.automationWorkflowType) {
      @case ('NATIVE') {
        <ng-container
          *ngTemplateOutlet="automationEligibilitySelectField"
        ></ng-container>
        @if (isTableVisible(componentData)) {
          <div>
            <div class="flex-row">
              <div class="automation-panel-grid-half">
                <ng-container *ngTemplateOutlet="priorityField"></ng-container>
                <ng-container
                  *ngTemplateOutlet="automationRequestStatusSelectField"
                ></ng-container>
              </div>
              <div class="automation-panel-grid-half">
                <ng-container *ngTemplateOutlet="uuidField"></ng-container>
                <ng-container
                  *ngTemplateOutlet="transmissionDateField"
                ></ng-container>
              </div>
            </div>
            <div class="automation-panel-grid m-t-10">
              <ng-container
                *ngTemplateOutlet="automationScriptField"
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="squashAutomFields"
              ></ng-container>
            </div>
          </div>
        }
      }
      @case ('NATIVE_SIMPLIFIED') {
        <ng-container
          *ngTemplateOutlet="automationEligibilitySelectField"
        ></ng-container>
        @if (isTableVisible(componentData)) {
          <div>
            <div class="flex-row">
              <div class="automation-panel-grid-half">
                <ng-container *ngTemplateOutlet="priorityField"></ng-container>
                <ng-container
                  *ngTemplateOutlet="automationRequestStatusSelectField"
                ></ng-container>
              </div>
              <div class="automation-panel-grid-half">
                <ng-container *ngTemplateOutlet="uuidField"></ng-container>
                @if (
                  shouldDisplayInNativeSimplifiedWorkflowType(componentData)
                ) {
                  <ng-container
                    *ngTemplateOutlet="transmissionDateField"
                  ></ng-container>
                }
              </div>
            </div>
            <div class="automation-panel-grid m-t-10">
              <ng-container
                *ngTemplateOutlet="automationScriptField"
              ></ng-container>
              <ng-container
                *ngTemplateOutlet="squashAutomFields"
              ></ng-container>
            </div>
          </div>
        }
      }
      @case ('REMOTE_WORKFLOW') {
        <ng-container
          *ngTemplateOutlet="automationEligibilitySelectField"
        ></ng-container>
        @if (isTableVisible(componentData)) {
          <div>
            <div class="flex-row">
              <div class="automation-panel-grid-half">
                <ng-container *ngTemplateOutlet="priorityField"></ng-container>
                <ng-container *ngTemplateOutlet="uuidField"></ng-container>
                <ng-container
                  *ngTemplateOutlet="transmissionDateField"
                ></ng-container>
                <ng-container
                  *ngTemplateOutlet="automationScriptField"
                ></ng-container>
              </div>
              <div class="automation-panel-grid-half">
                <ng-container
                  *ngTemplateOutlet="automationStatusField"
                ></ng-container>
                <ng-container
                  *ngTemplateOutlet="isAutomatedField"
                ></ng-container>
                <ng-container *ngTemplateOutlet="urlField"></ng-container>
                <ng-container
                  *ngTemplateOutlet="isAssignedToField"
                ></ng-container>
              </div>
            </div>
            <div class="automation-panel-grid">
              <ng-container
                *ngTemplateOutlet="squashAutomFields"
              ></ng-container>
            </div>
          </div>
        }
      }
    }
  } @else {
    <div class="automation-panel-grid">
      <ng-container *ngTemplateOutlet="automationScriptField"></ng-container>
      <ng-container *ngTemplateOutlet="squashAutomFields"></ng-container>
    </div>
  }
}

<ng-template #squashAutomFields>
  <ng-container *ngTemplateOutlet="technologySelectField"></ng-container>
  <ng-container *ngTemplateOutlet="scmRepoUrlSelectField"></ng-container>
  <ng-container *ngTemplateOutlet="automatedTestRefField"></ng-container>
</ng-template>

<ng-template #automationEligibilitySelectField>
  <div class="m-b-15 automation-panel-grid">
    <sqtm-core-label
      [text]="'sqtm-core.generic.label.automation.indicator' | translate"
    >
    </sqtm-core-label>
    <sqtm-core-editable-radio-button
      [attr.data-test-field-id]="'test-case-automatable'"
      [options]="automatableOptions"
      [value]="componentData.testCase.automatable"
      [editable]="editable"
      (confirmEvent)="changeAutomatable(componentData.testCase.id, $event)"
    >
    </sqtm-core-editable-radio-button>
  </div>
</ng-template>

<ng-template #priorityField>
  <sqtm-core-label
    [text]="'sqtm-core.generic.label.priority.numeric' | translate"
  >
  </sqtm-core-label>
  <sqtm-core-editable-text-field
    #automationRequestPriorityField
    [attr.data-test-field-id]="'test-case-automation-priority'"
    [size]="'small'"
    [editable]="editable"
    [value]="componentData.testCase.automationRequest.priority?.toString()"
    [layout]="'compact'"
    (confirmEvent)="
      changeAutomationRequestPriority(componentData.testCase.id, $event)
    "
  >
  </sqtm-core-editable-text-field>
</ng-template>

<ng-template #automationRequestStatusSelectField>
  <sqtm-core-label
    [text]="'sqtm-core.generic.label.automation.status' | translate"
  >
  </sqtm-core-label>
  <sqtm-core-editable-select-level-enum-field
    #autoRequestStatusField
    [attr.data-test-field-id]="'test-case-automation-request-status'"
    [size]="'small'"
    [layout]="'no-buttons'"
    [editable]="editable"
    [enumType]="'AutomationRequestStatus'"
    [excludedKeys]="automationStatusExcludedKeys"
    [selectedEnumItem]="componentData.testCase.automationRequest.requestStatus"
    (confirmEvent)="
      changeAutomationRequestStatus(componentData.testCase.id, $event)
    "
  >
  </sqtm-core-editable-select-level-enum-field>
</ng-template>

<ng-template #uuidField>
  <sqtm-core-label [text]="'sqtm-core.entity.test-case.uuid.label' | translate">
  </sqtm-core-label>
  <div class="flex-row">
    <p
      class="uuid-field"
      [attr.data-test-field-id]="'test-case-automation-uuid'"
      nz-tooltip
      [sqtmCoreLabelTooltip]
      nz-paragraph
      [(nzContent)]="componentData.testCase.uuid"
    ></p>
    <p
      class="uuid-copy"
      nz-paragraph
      nzCopyable
      [nzCopyText]="componentData.testCase.uuid"
      [nzCopyIcons]="['sqtm-core-generic:copy', 'sqtm-core-generic:confirm']"
    ></p>
  </div>
</ng-template>

<ng-template #automationScriptField>
  @if (isTaServerJenkinsKind) {
    <sqtm-core-label
      [text]="'sqtm-core.entity.test-case.script-auto' | translate"
    >
    </sqtm-core-label>
    <div class="flex-row overflow-hidden" style="align-items: center">
      @if (shouldDisplayMissingAutomationScriptWarning()) {
        <i
          nz-icon
          nzType="sqtm-core-generic:exclamation"
          nzTheme="outline"
          class="sqtm-core-warning-message table-icon-size m-r-5"
          nz-tooltip
          [nzTooltipTitle]="
            'sqtm-core.test-case-workspace.automation.error.mandatory-automation-field'
              | translate
          "
        >
        </i>
      }
      <sqtm-app-script-auto
        [testCaseViewComponentData]="componentData"
      ></sqtm-app-script-auto>
    </div>
  }
</ng-template>

<ng-template #transmissionDateField>
  <sqtm-core-label
    [text]="'sqtm-core.entity.automation-request.transmitted-on' | translate"
  >
  </sqtm-core-label>
  <span
    nz-tooltip
    [sqtmCoreLabelTooltip]
    [attr.data-test-field-id]="'test-case-automation-transmitted-on'"
  >
    {{ transmittedOn }}
  </span>
</ng-template>

<ng-template #automationStatusField>
  <sqtm-core-label
    [text]="'sqtm-core.generic.label.automation.status' | translate"
  >
  </sqtm-core-label>
  <div>
    @if (componentData.testCase.automationRequest.extender) {
      <span
        [attr.data-test-field-id]="'test-case-automation-remote-status'"
        nz-tooltip
        [sqtmCoreLabelTooltip]
      >
        {{ componentData.testCase.automationRequest.extender.remoteStatus }}
      </span>
    }
    @if (!componentData.testCase.automationRequest.extender) {
      <span>-</span>
    }
  </div>
</ng-template>

<ng-template #isAutomatedField>
  <sqtm-core-label [text]="'sqtm-core.entity.test-case.automated' | translate">
  </sqtm-core-label>
  <span [attr.data-test-field-id]="'test-case-automation-automated'">
    {{ isAutomated(componentData) }}
  </span>
</ng-template>

<ng-template #urlField>
  <sqtm-core-label [text]="'sqtm-core.entity.generic.url.label' | translate">
  </sqtm-core-label>
  <div class="automation-status-field">
    @if (componentData.testCase.automationRequest.extender) {
      <a
        [attr.data-test-field-id]="'test-case-automation-remote-request-url'"
        [href]="
          componentData.testCase.automationRequest.extender.remoteRequestUrl
        "
        [target]="'_blank'"
        nz-tooltip
        [sqtmCoreLabelTooltip]
      >
        {{ componentData.testCase.automationRequest.extender.remoteIssueKey }}
      </a>
    }
    @if (!componentData.testCase.automationRequest.extender) {
      <span>-</span>
    }

    @if (
      shouldShowSyncErrorMessage(
        componentData.testCase.automationRequest.extender
      )
    ) {
      <div>
        <span
          class="sync-error-message"
          [attr.data-test-field-id]="'tc-automation-sync-error-message'"
          >{{ syncErrorMessage | translate }}</span
        >
        <i
          nz-icon
          nzType="sqtm-core-generic:help"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="syncErrorTooltip | translate"
          class="current-workspace-button tooltip-icon table-icon-size"
        >
        </i>
      </div>
    }
  </div>
</ng-template>

<ng-template #isAssignedToField>
  <sqtm-core-label
    [text]="'sqtm-core.entity.automation-request.assigned-to.label' | translate"
  >
  </sqtm-core-label>
  <div>
    @if (componentData.testCase.automationRequest.extender) {
      <span
        [attr.data-test-field-id]="'test-case-automation-assigned-to'"
        nz-tooltip
        [sqtmCoreLabelTooltip]
      >
        {{ componentData.testCase.automationRequest.extender.remoteAssignedTo }}
      </span>
    }
    @if (!componentData.testCase.automationRequest.extender) {
      <span>-</span>
    }
  </div>
</ng-template>

<ng-template #technologySelectField>
  <sqtm-core-label
    [text]="
      'sqtm-core.test-case-workspace.automation.automated-test-technology.label'
        | translate
    "
  >
  </sqtm-core-label>
  <div class="flex-row overflow-hidden" style="align-items: center">
    @if (shouldDisplayMissingTechnologyWarning()) {
      <i
        nz-icon
        nzType="sqtm-core-generic:exclamation"
        nzTheme="outline"
        class="sqtm-core-warning-message table-icon-size m-r-5"
        nz-tooltip
        [nzTooltipTitle]="
          'sqtm-core.test-case-workspace.automation.error.mandatory-automation-field'
            | translate
        "
      >
      </i>
    }

    <sqtm-core-editable-select-field
      class="full-width"
      #technologyField
      [options]="technologyOptions"
      [value]="
        componentData.testCase.automatedTestTechnology
          ? componentData.testCase.automatedTestTechnology?.toString()
          : undefined
      "
      [editable]="isAutomFieldEditable()"
      [allowEmptyValue]="true"
      [attr.data-test-field-id]="'automationTechno'"
      [placeHolder]="'sqtm-core.generic.label.none.feminine' | translate"
      (confirmEvent)="changeAutomatedTestTechnology($event)"
      layout="no-buttons"
    >
    </sqtm-core-editable-select-field>
  </div>
</ng-template>

<ng-template #scmRepoUrlSelectField>
  <sqtm-core-label
    [text]="
      'sqtm-core.test-case-workspace.automation.source-code-repository-url.label'
        | translate
    "
  >
  </sqtm-core-label>
  <div class="flex-row overflow-hidden" style="align-items: center">
    @if (shouldDisplayMissingRepositoryUrlWarning()) {
      <i
        nz-icon
        nzType="sqtm-core-generic:exclamation"
        nzTheme="outline"
        class="sqtm-core-warning-message table-icon-size m-r-5"
        nz-tooltip
        [nzTooltipTitle]="
          'sqtm-core.test-case-workspace.automation.error.mandatory-automation-field'
            | translate
        "
      >
      </i>
    }

    <sqtm-core-editable-select-field
      class="full-width"
      [searchable]="true"
      [sqtmCoreGenericViewEditableSelectField]="keys.scmRepositoryId"
      [options]="scmRepoUrlOptions"
      [allowEmptyValue]="true"
      [placeHolder]="'sqtm-core.generic.label.none.masculine' | translate"
      [editable]="isAutomFieldEditable()"
      [attr.data-test-field-id]="'scmRepositoryId'"
      layout="no-buttons"
    >
    </sqtm-core-editable-select-field>
  </div>
</ng-template>

<ng-template #automatedTestRefField>
  <div class="flex-row overflow-hidden">
    <sqtm-core-label
      [text]="
        'sqtm-core.test-case-workspace.automation.automated-test-reference.label'
          | translate
      "
    >
    </sqtm-core-label>
    <div (click)="toAutomDevopsExternalDocumentation()">
      <i
        nz-icon
        nzType="sqtm-core-generic:help"
        nzTheme="outline"
        class="current-workspace-button table-icon-size m-l-5"
      >
      </i>
    </div>
  </div>

  <div class="flex-row overflow-hidden" style="align-items: center">
    @if (shouldDisplayMissingTestCaseReferenceWarning()) {
      <i
        nz-icon
        nzType="sqtm-core-generic:exclamation"
        nzTheme="outline"
        class="sqtm-core-warning-message table-icon-size m-r-5"
        nz-tooltip
        [nzTooltipTitle]="
          'sqtm-core.test-case-workspace.automation.error.mandatory-automation-field'
            | translate
        "
      >
      </i>
    }

    <sqtm-core-editable-text-field
      class="full-width"
      [sqtmCoreGenericViewEditableTextField]="keys.automatedTestReference"
      [editable]="isAutomFieldEditable()"
      [attr.data-test-field-id]="'AutomFieldEditable'"
      layout="compact"
    >
    </sqtm-core-editable-text-field>
  </div>
</ng-template>
